[BACK]Return to fw_install.sh CVS log [TXT][DIR] Up to [local] / openbsd / fw_update

Diff for /openbsd/fw_update/fw_install.sh between version 1.87 and 1.95

version 1.87, 2021/12/18 23:02:20 version 1.95, 2021/12/21 02:16:47
Line 15 
Line 15 
 # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF  # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.  # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
   
 set -o errexit -o pipefail -o nounset  set -o errexit -o pipefail -o nounset -o noclobber -o noglob
 set +o monitor  set +o monitor
 export PATH=/usr/bin:/bin:/usr/sbin:/sbin  export PATH=/usr/bin:/bin:/usr/sbin:/sbin
   
Line 55 
Line 55 
 }  }
   
 fetch() {  fetch() {
         local _src="${FWURL}/${1##*/}" _dst=$1 _user=_file _pid _exit          local _src="${FWURL}/${1##*/}" _dst=$1 _user=_file _pid _exit _error=''
   
         # If we're not in the installer,          # If we're not in the installer,
         # we have su(1) and doas(1) is unlikely to be configured.          # we have su(1) and doas(1) is unlikely to be configured.
Line 84 
Line 84 
                                 sleep 1                                  sleep 1
                         else                          else
                                 kill -INT -"$_pid"                                  kill -INT -"$_pid"
                                 echo "fetch timed out" >&2                                  _error=" (timed out)"
                         fi                          fi
                 else                  else
                         sleep 1                          sleep 1
Line 100 
Line 100 
   
         if [ "$_exit" -ne 0 ]; then          if [ "$_exit" -ne 0 ]; then
                 rm -f "$_dst"                  rm -f "$_dst"
                 echo "Cannot fetch $_src" >&2                  echo "Cannot fetch $_src$_error" >&2
                 return 1                  return 1
         fi          fi
 }  }
Line 114 
Line 114 
 }  }
   
 devices_needing_firmware() {  devices_needing_firmware() {
         local _d _m _line _dmesgtail _last=''          local _d _m _line _dmesgtail _last='' _nl=$( echo )
   
         # When we're not in the installer, the dmesg.boot can          # When we're not in the installer, the dmesg.boot can
         # contain multiple boots, so only look in the last one          # contain multiple boots, so only look in the last one
         sed -n 'H;/^OpenBSD/h;${g;p;}' /var/run/dmesg.boot |          _dmesgtail="$( echo ; sed -n 'H;/^OpenBSD/h;${g;p;}' /var/run/dmesg.boot |
             grep -e "^[a-z][a-z]*[0-9]" -e " not configured " | { \              grep -e "^[a-z][a-z]*[0-9]" -e " not configured " )"
                 _m=0  
                 set -A _dmesgtail  
                 while read -r _line; do  
                         _dmesgtail[$_m]="$_line"  
                         _m=$(( _m + 1 ))  
                 done  
   
                 grep -v '^[[:space:]]*#' "$FWPATTERNS" |          grep -v '^[[:space:]]*#' "$FWPATTERNS" |
                     while read -r _d _m; do              while read -r _d _m; do
                         [ "$_d" = "$_last" ] && continue                  [ "$_d" = "$_last" ] && continue
                         [ "$_m" ] || _m="^${_d}[0-9] at "                  [ "$_m" ]             || _m="${_nl}${_d}[0-9] at "
                   [ "$_m" = "${_m#^}" ] || _m="${_nl}${_m#^}"
   
                         if [ "$_m" = "${_m#^}" ]; then                  if [[ $_dmesgtail = *$_m* ]]; then
                                 _m="*$_m"                          echo "$_d"
                         else                          _last="$_d"
                                 _m="${_m#^}"                  fi
                         fi              done
   
                         for _line in "${_dmesgtail[@]}"; do  
                                 if [[ $_line = ${_m}* ]]; then  
                                         echo "$_d"  
                                         _last="$_d"  
                                 fi  
                         done  
                     done  
         }  
 }  }
   
 firmware_filename() {  firmware_filename() {
Line 162 
Line 148 
 }  }
   
 installed_firmware() {  installed_firmware() {
           set +o noglob
         for fw in "${DESTDIR}/var/db/pkg/$1-firmware"*; do          for fw in "${DESTDIR}/var/db/pkg/$1-firmware"*; do
                 [ -e "$fw" ] || continue                  [ -e "$fw" ] || continue
                 echo "${fw##*/}"                  echo "${fw##*/}"
         done          done
           set -o noglob
 }  }
   
 add_firmware () {  add_firmware () {
Line 213 
Line 201 
                 if [ -d "$_r" ]; then                  if [ -d "$_r" ]; then
                         # Try hard not to actually remove recursively                          # Try hard not to actually remove recursively
                         # without rmdir on the install media.                          # without rmdir on the install media.
                           set +o noglob
                         [ "$_r/*" = "$( echo "$_r"/* )" ] && rm -rf "$_r"                          [ "$_r/*" = "$( echo "$_r"/* )" ] && rm -rf "$_r"
                           set -o noglob
                 else                  else
                         rm -f "$_r"                          rm -f "$_r"
                 fi                  fi
Line 221 
Line 211 
 }  }
   
 usage() {  usage() {
         echo "usage: fw_install [-D | -L] [driver | file [...]]"          echo "usage:  ${0##*/} [-D | -L] [driver | file ...]"
         exit 2          exit 2
 }  }
   
Line 253 
Line 243 
   
 CFILE="$LOCALSRC/$CFILE"  CFILE="$LOCALSRC/$CFILE"
   
   if "$INSTALL" && [ -x /usr/bin/id ] && [ $(/usr/bin/id -u) != 0 ]; then
           echo "need root privileges" >&2
           exit 1
   fi
   
 set -A devices -- "$@"  set -A devices -- "$@"
   
 [ "${devices[*]:-}" ] ||  
     set -A devices -- $( devices_needing_firmware )  
   
 if [ ! "${devices[*]:-}" ]; then  if [ ! "${devices[*]:-}" ]; then
         echo "No devices found which need firmware files to be downloaded."          echo -n "Detecting firmware ..."
         exit          set -A devices -- $( devices_needing_firmware )
           [ "${devices[*]:-}" ] && echo " found." || echo " done."
 fi  fi
   
   [ "${devices[*]:-}" ] || exit
   
 if "$DOWNLOAD"; then  if "$DOWNLOAD"; then
         fetch "$CFILE"          fetch "$CFILE"

Legend:
Removed from v.1.87  
changed lines
  Added in v.1.95

FreeBSD-CVSweb <freebsd-cvsweb@FreeBSD.org>